# $COPYRIGHT$
# 
# Additional copyrights may follow
# 
# $HEADER$
#
############################################################################


#############################################################################
#
# Configuration Options
#
#############################################################################

# Path to mpi home
# type: string 
%{!?path_to_mpihome: %define path_to_mpihome /usr/local/mpi}

# Name for tests home directory
# type: string 
%{!?test_home: %define test_home %{path_to_mpihome}/tests}

# Some compilers can be installed via tarball or RPM (e.g., Intel,
# PGI).  If they're installed via RPM, then rpmbuild's auto-dependency
# generation stuff will work fine.  But if they're installed via
# tarball, then rpmbuild's auto-dependency generation stuff will
# break; complaining that it can't find a bunch of compiler .so files.
# So provide an option to turn this stuff off.
# type: bool (0/1)
%{!?disable_auto_requires: %define disable_auto_requires 0}

#############################################################################
#
# Configuration Logic
#
#############################################################################
%define _prefix %{path_to_mpihome}
%define _sysconfdir %{path_to_mpihome}/etc
%define _libdir %{path_to_mpihome}/lib
%define _includedir %{path_to_mpihome}/include
# disable debuginfo
%define debug_package %{nil}
# disable broken macro - check_files
%define __check_files %{nil}
# Some compilers can be installed via tarball or RPM (e.g., Intel,
# PGI).  If they're installed via RPM, then rpmbuild's auto-dependency
# generation stuff will work fine.  But if they're installed via
# tarball, then rpmbuild's auto-dependency generation stuff will
# break; complaining that it can't find a bunch of compiler .so files.
# So provide an option to turn this stuff off.
# type: bool (0/1)
%{!?disable_auto_requires: %define disable_auto_requires 0}

#############################################################################
#
# Preamble Section
#
#############################################################################

Summary: MPI Benchmarks and tests
Name: %{?_name:%{_name}}%{!?_name:mpitests}
Version: 4.0
Release: 931
License: BSD
Group: Applications
Source: mpitests-%{version}.tar.gz
Packager: %{?_packager:%{_packager}}%{!?_packager:%{_vendor}}
Vendor: %{?_vendorinfo:%{_vendorinfo}}%{!?_vendorinfo:%{_vendor}}
Distribution: %{?_distribution:%{_distribution}}%{!?_distribution:%{_vendor}}
Prefix: %{_prefix}
Provides: mpitests
BuildRoot: %{?buildroot:%{buildroot}}%{!?buildroot:/var/tmp/%{name}-%{version}-%{release}-root}
%if %{disable_auto_requires}
AutoReq: no
%endif

%description
Set of popular MPI benchmarks:
IMB-4.0
OSU benchmarks ver 3.8

#############################################################################
#
# Prepatory Section
#
#############################################################################
%prep
%setup -q -n mpitests-%{version}

%install
%{__make} MPIHOME=%{path_to_mpihome}

#############################################################################
#
# Install Section
#
#############################################################################
%{__make} MPIHOME=$RPM_BUILD_ROOT/%{path_to_mpihome} install


#############################################################################
#
# Clean Section
#
#############################################################################
%clean
# We should leave build root for IBED installation
# test "x$RPM_BUILD_ROOT" != "x" && rm -rf $RPM_BUILD_ROOT


#############################################################################
#
# Post (Un)Install Section
#
#############################################################################
%post
# Stub

%postun
# Stub

#############################################################################
#
# Files Section
#
#############################################################################


%files 
%defattr(-, root, root)
%dir %{test_home}
%dir %{test_home}/IMB-4.0
%{test_home}/IMB-4.0/IMB-MPI1
%dir %{test_home}/osu-micro-benchmarks-3.8
%dir %{test_home}/osu-micro-benchmarks-3.8/mpi
%dir %{test_home}/osu-micro-benchmarks-3.8/mpi/pt2pt
%dir %{test_home}/osu-micro-benchmarks-3.8/mpi/collective
%{test_home}/osu-micro-benchmarks-3.8/mpi/pt2pt/osu_bw
%{test_home}/osu-micro-benchmarks-3.8/mpi/pt2pt/osu_bibw
%{test_home}/osu-micro-benchmarks-3.8/mpi/pt2pt/osu_latency
%{test_home}/osu-micro-benchmarks-3.8/mpi/collective/osu_bcast
%{test_home}/osu-micro-benchmarks-3.8/mpi/collective/osu_alltoall
%{test_home}/osu-micro-benchmarks-3.8/mpi/pt2pt/osu_mbw_mr
%{test_home}/osu-micro-benchmarks-3.8/mpi/pt2pt/osu_multi_lat
%dir %{test_home}/intel
%{test_home}/intel/mpi_nxnlatbw
%{test_home}/intel/mpi_multibw
%{test_home}/intel/mpi_stress
%{test_home}/intel/deviation
%{test_home}/intel/mpi_groupstress

#############################################################################
#
# Changelog
#
#############################################################################
%changelog
* Tue Mar 8 2016 Nikhilesh Payyavuala (nikhilesh.payyavuala@intel.com)
  Fix for a memory leak when using the -y option
* Thu Mar 3 2016 Nikhilesh Payyavuala (nikhilesh.payyavuala@intel.com)
  Fix a memory leak in the benchmark.
* Fri Feb 19 2016 Brandon Yates (brandon.yates@intel.com)
  Fixing devation test tol/delta logic
* Thu Feb 11 2016 Kyle Liddell (kyle.liddell@intel.com)
  Trivial makefile and mpi_stress updates to remove ancient dependencies
* Sat Dec 12 2015 Matias A Cabral (matias.a.cabral@intel.com)
  Extended explanation to -a option to print the values must be multiple
  of sizeof(void*)
  The patch was provided by John Fleck, Intel.
* Mon Oct 19 2015 Brandon Yates (brandon.yates@intel.com)
  Added mpi_groupstress test to mpitests
* Mon Oct 5 2015 Brandon Yates (brandon.yates@intel.com)
  Added intel deviation test to mpitests RPM
* Fri Sep 11 2015 John Fleck (john.fleck@intel.com)
  Remove IMB-3.1 and osu_benchmarks-3.0
* Tue Feb 24 2015 John Fleck (john.fleck@intel.com)
  Remove trigger function in mpi_stress
* Mon Jan  5 2015 Kyle Liddell (kyle.liddell@intel.com)
  mpi_stress improvements
  The patch was provided by John Fleck, Intel.
* Wed Apr  7 2010 Pavel Shamis (pasha@mellanox.co.il)
  disable_auto_requires configuration option was added
  The patch was provided by Todd Rimmer, Qlogic.
* Sun Nov 15 2009 Pavel Shamis (pasha@mellanox.co.il)
  Intel MPI benchmark IMB-3.1 was updated to IMB-3.2
  OSU MPI benchmark version 3.0 was updated to 3.1.1
* Thu Oct  2 2008 Pavel Shamis (pasha@mellanox.co.il)
  Intel MPI benchmark IMB-3.0 was updated to IMB-3.1
* Thu Nov 22 2006 Pavel Shamis (pasha@mellanox.co.il)
  Intel MPI benchmark IMB-2.3 was updated to IMB-3.0
  OSU benchmarks were updated from 2.0 to 3.0
  mpitest package version updated from 2.0 to 3.0
  removing old code from spec
* Tue Jun 20 2006 Pavel Shamis (pasha@mellanox.co.il)
  Pallas benchmark 2.2.1 was replaced with Intel MPI benchmark IMB-2.3
  Presta 1.2 was updated to 1.4.0
  OSU benchmarks were updated from 1.0 to 2.0
  mpitest package version updated from 1.0 to 2.0
* Wed Apr 01 2006 Pavel Shamis (pasha@mellanox.co.il)
  Spec file for mpitests was created.
